clear all; close all; clc;

CaseName = 'Cq'; % Case name: Cq or D
% CaseName = 'D';

CaseNumber = 1; % Case number: 1~6
% CaseNumber = [1,2,3,4,5,6];

for ii = CaseNumber
    
    %% Parameters for PSD
    
    H_l = [0 0.2 0.4 0.6 0.8 1]*2; 
    H = H_l(ii); % Hurst Exponent
    Lx = 15; % Length
    m= 1500; % number of points within Lx
    
    q0 = 0; % minimum wavenumber 
    qr = 0.4667; % roll-off wavenumber
    qS = 2.7; % maximum wavenumber
    qC = qS;
    
    if CaseName(1) == 'D'
        % Case_D
        Cq0 = 10^-3; % maximum spectral density
    else
        % Case_Cq
        H=1;
        Cq0_l =logspace(-4,-2,6); Cq0 = Cq0_l(ii); % maximum spectral density
    end
    
    %% Generating PSD 
    [z, PSD] = artificial_surf1d_phaseC_4TU(Cq0, H, Lx, m, q0,qr, qS,qC);
    eval(['z',num2str(ii),'=z;']) % artificial riverbed elevation
    eval(['PSD',num2str(ii),'=PSD;']) % PSD of z
    
    Fs = m/Lx; X = 1/Fs; xx = (0:m-1)*X; freq = Fs*(0:m-1)/m;
    % Fs: spatial frequency, xx: x-dir location

    figure(2); loglog(freq,(PSD.Bq).^2/(Fs)^2/Lx,'linewidth',3); hold on;
    xlabel('Wavelength (m^-^1)'); ylabel('Power spectrum (m^2)')
    xlim([10^-1 10^1]); 
    grid on;
    
    figure(3); plot(freq,PSD.phi); hold on;

    figure(10); 
    plot(xx(2:end-1),z(2:end-1),'linewidth',2); 
    hold on;

    psd = (PSD.Bq).^2/(Fs)^2/Lx;
end
